# encoding: utf-8
# frozen_string_literal: true
module TTWatcher
  module Helpers
    extend self

    ##
    # Returns symbolized class name.
    #
    # @example
    #   site = TTWatcher::Sites:Rutor.new
    #   H::class_name(site) # ==> :rutor
    #
    # @return [Symbol]

    def class_name(klass)
      klass_name =
        klass.class.name.to_s.split('::').last.downcase.to_sym

      return klass_name
    end
  end # module Helpers
  H = Helpers
end # module TTWatcher
