# encoding: utf-8
# frozen_string_literal: true
module TTWatcher
  module Logger
    def self.extended(mod)
      @level = :standard
    end
    extend self

    # @return [Symbol] (:normal)
    #   Verbose level, possible values :development, :standard, :disabled:

    attr_accessor :level

    ##
    # Prints customized message with backtrace to last exception.
    #
    # @param [String] msg

    def with_backtrace(msg)
      puts "\n", msg

      puts "\n", "**** Backtrace ****".center(100), "\n"
      puts $@.join("\n"), "\n"
      puts "**** End ****".center 100
    end

    def logger
      @logger || $stdout
    end

    def logger=(new_logger)
      @logger = new_logger
    end

    def <<(*args)
      Array(args).each { |arg| logger.puts arg}
    end
  end # module Logger
end # module TTWatcher
