# encoding: utf-8
# frozen_string_literal: true
module TTWatcher
  # Dependencies from core lib

  require 'forwardable'
  require 'json'
  require 'date'
  require 'yaml'

  # Dependencies from rubygems.org

  require "addressable/uri"
  require 'nokogiri'
  require 'rest-client'
  require 'deep_merge'

  # Project structure

  # Core class for all exceptions that can be raised in TTWatcher.

  class TTWError < StandardError; end

  ##
  # Loads *.rb files in requested order

  def self.load(**params)
    params[:files].each do |f|
      require File.join(__dir__, params[:folder].to_s, f)
    end
  end
  private_class_method :load

  load files: %w(helpers logger torrent torrent_list)

  load folder: 'sites/connection',
       files: %w(scheme url)

  load folder: "sites",
       files:  %w(connection config)

  load folder: 'sites/parsers',
       files: %w(abstract_parser simple_parser rutor_parser megashara_parser
                 unionpeer_parser zooqle_parser)

  load folder: 'sites',
       files: %w(site torrent_site rutor megashara unionpeer zooqle)

  load files: %w(sites torrent_agent)
end # module TTWatcher
